package com.gmscheduler.model;

/**
 * A <code>Person</code> object represents the owner of schedule.
 * 
 * @author Peter Deschere
 * @version 1.0
 *
 */
public class Person {
    //class constructor
	public Person(String name) {
		this.name = new String(name);
	}
	
	//copy constructor
	public Person(Person u) {
		name = new String(u.getName()); 
	}
	
	//default constructor
	public Person() {
		name = null;
	}
	
	/**
	 * Returns the name.
	 * 
	 * @return the name of the <code>Person</code>
	 */
	public String getName() {
		if (name==null) { return "";} else { return name;}
	}

	/**
	 * Sets the name.
	 * 
	 * @param name the new name
	 */
	public void setName(String name) {
		this.name = new String(name); 
	}
	
	public String toString() {
		if (name == null) {return "";} else {return name;}
	}
	
	/**
	 * The <code>Person</code>'s name
	 */
	private String name;
}
