package com.gmscheduler.unittests;

import junit.framework.TestCase;
import junit.framework.Assert;
import com.gmscheduler.model.Person;
import com.gmscheduler.model.Timeframe;
import com.gmscheduler.model.Schedule;
import java.util.LinkedList;

public class ScheduleTest extends TestCase {

	private Person p1;
	private Timeframe t1;
	private Schedule s1;
	private Schedule s2;
	private Person p3;
	private Timeframe t3;
	private Schedule s3;
	private Timeframe t4;
	private LinkedList lt4;
	private Schedule s4;
	
	protected void setUp() throws Exception {
		p1 = new Person("John");
		t1 = new Timeframe("M","10:00am","1:00pm");
		s1 = new Schedule(p1,t1);
		s2 = new Schedule(s1);
		p3 = new Person("Mary Jo");
		t3 = new Timeframe("M","10:00am","1:00pm");
		s3 = new Schedule(p3,t3);
		t4 = new Timeframe("T","4:00pm","5:00pm");
		lt4 = new LinkedList();
		lt4.add(t1);
		lt4.add(t4);
		s4 = new Schedule(p3,lt4);
	}

	protected void tearDown() throws Exception {
		super.tearDown();
	}

	public void testScheduleEquals() {
		Assert.assertEquals(s1.toString(),s2.toString());
		Assert.assertTrue(!s4.equals(s3));
	}
	
}
