/**
 * Yana Novikova
 * Java file for the servlet
 */
package com.gmscheduler.web;

import com.gmscheduler.model.*;
import javax.servlet.*;
import javax.servlet.http.*;
import java.io.*;
import java.util.*;

/**
 * This class gets the strings from the form, converts them to the Schedule
 * objects and finds the time using ScheduleUtil class  and puts it into result page
 */
public class ScheduleExpert extends HttpServlet {
    
    /**
     * This function perform HTTP post operation
     */
    public void doPost(HttpServletRequest request,
		       HttpServletResponse response)
	throws IOException, ServletException {

	//get strings from the form
	String o = request.getParameter("one");
	String t = request.getParameter("two");
	String th = request.getParameter("three");
	String fr = request.getParameter("four");
	String f = request.getParameter("frame");

	ScheduleUtil su = new ScheduleUtil();

	//parse each of them into the schedule
	Schedule one = new Schedule(su.parseSchedule(o));
	Schedule two = new Schedule(su.parseSchedule(t));
	Schedule three = new Schedule(su.parseSchedule(th));
	Schedule four = new Schedule(su.parseSchedule(fr));
	Schedule freetime = new Schedule(su.parseSchedule(f));

	one.setPerson(new Person("user1"));
	two.setPerson(new Person("user2"));
	three.setPerson(new Person("user3"));
	four.setPerson(new Person("user4"));
	freetime.setPerson(new Person("freetime is the following"));

	//put them into the linked list
	LinkedList list = new LinkedList();
	list.add(one);
	list.add(two);
	list.add(three);
	list.add(four);

	//find free schedule using ScheduleUtil
	Schedule free = new Schedule(su.findTime(freetime, list));

	//convert Schedule to string
	String res = free.toString();
	
	//put it on the JSP
	request.setAttribute("schedule", res);
	RequestDispatcher view = request.getRequestDispatcher("result.jsp");
	view.forward(request, response);
    }

    /** 
     * Constructor for the servlet class
     */
    public void ScheduleExpert() {
    }
}

